#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include "uhs2html.h"

#include "version.h"

int verbose=0;

int main(int argc, char** argv)
{
	char buffer[BUFLEN];
	char outdir[BUFLEN];
	char* point;
	FILE* hintfile;
	int argoffset=1;

	if(argc<2 || argc>4)
	{
		fprintf(stderr,"%s version " VERSION " (last changed " CHANGED ")\n",argv[0]);
		fprintf(stderr,"converts UHS (Universal Hint System) hint files to HTML.\n\n");
		fprintf(stderr,"Usage: %s [-v] <hint file> [<output directory>]\n",argv[0]);
		exit(42);
	}
	
	while(*argv[argoffset]=='-')
	{
		switch(*(argv[1]+1))
		{
			case 'v':
				verbose=1;
				break;
		}
		argc--;argoffset++;
	}

	hintfile=fopen(argv[argoffset],"r");
	if(!hintfile)
	{
		perror(argv[argoffset]);
		exit(1);
	}

	if(argc==3)
		strcpy(outdir,argv[argoffset+1]);
	else
	{
		point=strstr(argv[argoffset],".");
		if(point)
		{
			*point=0;
			strcpy(outdir,argv[argoffset]);
		}
		else
		{
			strcpy(outdir,argv[argoffset]);
			strcat(outdir,".d");
		}
	}
	
	if(mkdir(outdir,0777))
	{
		perror(outdir);
		exit(3);
	}
	if(chdir(outdir))
	{
		perror(outdir);
		exit(4);
	}

	strcpy(maintitle,"(unknown)");
	while(myfgets(buffer,BUFLEN,hintfile)&&strncmp(buffer,"** END OF ",10)&&!feof(hintfile));
	if(feof(hintfile))
	{
		fseek(hintfile,0,SEEK_SET);
		oldformat(hintfile);
		exit(2);
	}
	subject(hintfile,NULL,"index.html",-1);
	fclose(hintfile);
	return 0;
}

