#include "uhs2html.h"

/* transstring() does the actual hint "decoding". The algorithm is guesswork, but seems
   to work just fine. */
void transstring(char* str)
{
	while(*str)
	{
		if(*str > 0x20) {
			if(*str >= 0x50)
				*str=(*str-0x40)*2+1;
			else
				*str=(*str*2)-0x20;
		}
		str++;
	}
}

void subject(FILE* hf,char* title,char* htmlname, int l)
{
	int counter,i;
	char buffer[BUFLEN];
	char* spacepos;
	char tmp2[BUFLEN];
	FILE* html;
	
	int lines=0;
	if(l==-1)
		l=1000000000;

#ifdef DEBUG
	if(title) printf("SUBJECT: %s\n",title);
#endif
	if(title && !maintitleset)	/* make the first valid title the main title */
	{
		maintitleset=1;
		strcpy(maintitle,title);
	}
	
	html=fopen(htmlname,"w+");
	htmlhead(html,title);
		
	for(counter=0;(counter<l-2)&&!feof(hf);counter++)
	{
		if(!myfgets(buffer,BUFLEN,hf)) break;
		spacepos=strstr(buffer," ");
		if(!spacepos) continue;
		*spacepos=0;
		lines=atoi(buffer);	/* length of this section */
		if(!strcmp(spacepos+1,"subject"))
		{
			myfgets(buffer,BUFLEN,hf);	/* get subject title */
			
			strcpy(tmp2,buffer);		/* construct html file name */
			spc2uscore(tmp2);
			strcat(tmp2,".html");
			
			htmlsubjectlink(html,buffer,tmp2);

			subject(hf,buffer,tmp2,lines);	/* call self to process (sub)subject */
			counter+=lines;
		}
		else if(!strcmp(spacepos+1,"hint"))
		{
			myfgets(buffer,BUFLEN,hf);	/* get hint tile */

			strcpy(tmp2,buffer);		/* construct html title without .html extension
							   which is added by hint() itself */
			spc2uscore(tmp2);
			
			hint(hf,buffer,tmp2,lines);

			strcat(tmp2,".html");
			htmlhintlink(html,buffer,tmp2);

			counter+=lines;
		}
		else if(!strcmp(spacepos+1,"text"))
		{
			/* FIXME
			   These sections seem to point at some binary data at the end of the file, after
			   the terminating ^Z character.
			 */
			myfgets(buffer,BUFLEN,hf);	/* get text section title */

			fprintf(html,"<br>Text: %s\n",buffer);
			fprintf(html,"<br>(sorry, cannot decode section)\n");

			if(verbose) printf("TEXT SECTION %s, dumping:\n",buffer);
			for(i=0;i<lines-2;i++)
			{
				if(verbose) printf("%s\n",myfgets(buffer,BUFLEN,hf));
			}
			if(verbose) printf("END OF DUMP\n");

			counter+=lines;
		}
		else if(!strcmp(spacepos+1,"nesthint"))
		{
			/* FIXME
			   nesthint sections seem to have a different encoding. They also have link
			   sections that seem to connect to other hints.
			 */
			myfgets(buffer,BUFLEN,hf);	/* get nesthint section title */

			fprintf(html,"<br>Nested hint: %s\n",buffer);
			fprintf(html,"<br>(sorry, cannot decode section)\n");

			if(verbose) printf("NESTHINT SECTION %s, dumping:\n",buffer);
			for(i=0;i<lines-2;i++)
			{
				myfgets(buffer,BUFLEN,hf);
				if(verbose) printf("%s\n",buffer);
			}
			if(verbose) printf("END OF DUMP\n");

			counter+=lines;
		}
		else if(!strcmp(spacepos+1,"comment"))
		{
			myfgets(buffer,BUFLEN,hf);	/* get comment title */
			
			fprintf(html,"<br><i>%s</i>\n<pre>",buffer);
			
			for(i=0;i<lines-2;i++)
			{
				myfgets(buffer,BUFLEN,hf);
				fprintf(html,"%s\n",buffer);
			}
			fputs("</pre><br>\n",html);
			counter+=lines;
		}
		else
		{
			/* dump unknown sections to stdout */

			if(verbose) printf("UNKNOWN SECTION %s, dumping:\n",spacepos+1);
			for(i=0;i<lines-1;i++)
			{
				myfgets(buffer,BUFLEN,hf);
				if(verbose) printf("%s\n",buffer);
			}
			if(verbose) printf("END OF DUMP\n");

			counter+=lines;
		}
	}
	htmlfoot(html);
	fclose(html);
}

void hint(FILE* hf, char* title, char* htmlname, int l)
{
	char buffer[BUFLEN];
	char* hints[l];		/* to contain all hints in this section */
	int counter;
	int hintcount=0;	/* number of hints found */
	int tmp;
	char tmp2[BUFLEN];
	FILE* html;
	int i;
	
	memset(hints,0,sizeof(hints));
	
#ifdef DEBUG
	printf("QUESTION: %s\n",title);
	fflush(stdout);
#endif
	for(counter=0;counter<l-2;counter++)
	{
		myfgets(buffer,BUFLEN,hf);
		if(*buffer=='-')	/* - lines separate the different hint stages from each other */
		{
			transstring(hints[hintcount]);	/* "decode" assembled hint */
#ifdef DEBUG
			printf("HINT %d: %s",hintcount,hints[hintcount]);
			fflush(stdout);
#endif
			hintcount++;
			continue;
		}
		if(!hints[hintcount])	/* create a new hint stage */
		{
			tmp=strlen(buffer)+2;
#ifdef DEBUG
			printf("allocing %d\n",tmp);
			fflush(stdout);
#endif
			hints[hintcount]=(char*)malloc(tmp);
#ifdef DEBUG
			printf("returned %x\n",(unsigned int)hints[hintcount]);
			fflush(stdout);
#endif
			*hints[hintcount]=0;
		}
		else			/* append a new line to the current hint stage */
		{
			tmp=strlen(hints[hintcount])+strlen(buffer)+2;
#ifdef DEBUG
			printf("reallocing %d\n",tmp);
			fflush(stdout);
#endif
			hints[hintcount]=(char*)realloc(hints[hintcount],tmp);
#ifdef DEBUG
			printf("returned %x\n",(unsigned int)hints[hintcount]);
			fflush(stdout);
#endif
		}
		strcat(hints[hintcount],buffer); strcat(hints[hintcount],"\n");
	}

	for(counter=0;counter<hintcount;counter++)
	{
		/* compose the html file name */
		strcpy(tmp2,htmlname);
		if(counter)	/* append number if not first hint stage */
		{
			sprintf(buffer,"_%d",counter);
			strcat(tmp2,buffer);
		}
		strcat(tmp2,".html");

		html=fopen(tmp2,"w+");
		htmlhead(html,title);

		for(i=0;i<counter+1;i++)
		{
			htmlhint(html,i+1,hintcount,hints[i]);
		}

		if(counter<hintcount-1)
			htmlnexthintlink(html,htmlname,i);

		htmlfoot(html);
		fclose(html);
	}

	for(counter=0;counter<hintcount;counter++)
		free(hints[counter]);
}
